package mega.privacy.android.app.components.twemoji.category;

import androidx.annotation.DrawableRes;
import androidx.annotation.NonNull;

import mega.privacy.android.app.R;
import mega.privacy.android.app.components.twemoji.emoji.Emoji;
import mega.privacy.android.app.components.twemoji.emoji.EmojiCategory;


public final class ObjectsCategory implements EmojiCategory {
  private static final Emoji[] DATA = new Emoji[] {
    new Emoji(0x231a, R.drawable.emoji_twitter_231a),
    new Emoji(0x1f4f1, R.drawable.emoji_twitter_1f4f1),
    new Emoji(0x1f4f2, R.drawable.emoji_twitter_1f4f2),
    new Emoji(0x1f4bb, R.drawable.emoji_twitter_1f4bb),
    new Emoji(0x2328, R.drawable.emoji_twitter_2328),
    new Emoji(0x1f5a5, R.drawable.emoji_twitter_1f5a5),
    new Emoji(0x1f5a8, R.drawable.emoji_twitter_1f5a8),
    new Emoji(0x1f5b1, R.drawable.emoji_twitter_1f5b1),
    new Emoji(0x1f5b2, R.drawable.emoji_twitter_1f5b2),
    new Emoji(0x1f579, R.drawable.emoji_twitter_1f579),
    new Emoji(0x1f5dc, R.drawable.emoji_twitter_1f5dc),
    new Emoji(0x1f4bd, R.drawable.emoji_twitter_1f4bd),
    new Emoji(0x1f4be, R.drawable.emoji_twitter_1f4be),
    new Emoji(0x1f4bf, R.drawable.emoji_twitter_1f4bf),
    new Emoji(0x1f4c0, R.drawable.emoji_twitter_1f4c0),
    new Emoji(0x1f4fc, R.drawable.emoji_twitter_1f4fc),
    new Emoji(0x1f4f7, R.drawable.emoji_twitter_1f4f7),
    new Emoji(0x1f4f8, R.drawable.emoji_twitter_1f4f8),
    new Emoji(0x1f4f9, R.drawable.emoji_twitter_1f4f9),
    new Emoji(0x1f3a5, R.drawable.emoji_twitter_1f3a5),
    new Emoji(0x1f4fd, R.drawable.emoji_twitter_1f4fd),
    new Emoji(0x1f39e, R.drawable.emoji_twitter_1f39e),
    new Emoji(0x1f4de, R.drawable.emoji_twitter_1f4de),
    new Emoji(0x260e, R.drawable.emoji_twitter_260e),
    new Emoji(0x1f4df, R.drawable.emoji_twitter_1f4df),
    new Emoji(0x1f4e0, R.drawable.emoji_twitter_1f4e0),
    new Emoji(0x1f4fa, R.drawable.emoji_twitter_1f4fa),
    new Emoji(0x1f4fb, R.drawable.emoji_twitter_1f4fb),
    new Emoji(0x1f399, R.drawable.emoji_twitter_1f399),
    new Emoji(0x1f39a, R.drawable.emoji_twitter_1f39a),
    new Emoji(0x1f39b, R.drawable.emoji_twitter_1f39b),
    new Emoji(0x23f1, R.drawable.emoji_twitter_23f1),
    new Emoji(0x23f2, R.drawable.emoji_twitter_23f2),
    new Emoji(0x23f0, R.drawable.emoji_twitter_23f0),
    new Emoji(0x1f570, R.drawable.emoji_twitter_1f570),
    new Emoji(0x231b, R.drawable.emoji_twitter_231b),
    new Emoji(0x23f3, R.drawable.emoji_twitter_23f3),
    new Emoji(0x1f4e1, R.drawable.emoji_twitter_1f4e1),
    new Emoji(0x1f50b, R.drawable.emoji_twitter_1f50b),
    new Emoji(0x1f50c, R.drawable.emoji_twitter_1f50c),
    new Emoji(0x1f4a1, R.drawable.emoji_twitter_1f4a1),
    new Emoji(0x1f526, R.drawable.emoji_twitter_1f526),
    new Emoji(0x1f56f, R.drawable.emoji_twitter_1f56f),
    new Emoji(0x1f5d1, R.drawable.emoji_twitter_1f5d1),
    new Emoji(0x1f6e2, R.drawable.emoji_twitter_1f6e2),
    new Emoji(0x1f4b8, R.drawable.emoji_twitter_1f4b8),
    new Emoji(0x1f4b5, R.drawable.emoji_twitter_1f4b5),
    new Emoji(0x1f4b4, R.drawable.emoji_twitter_1f4b4),
    new Emoji(0x1f4b6, R.drawable.emoji_twitter_1f4b6),
    new Emoji(0x1f4b7, R.drawable.emoji_twitter_1f4b7),
    new Emoji(0x1f4b0, R.drawable.emoji_twitter_1f4b0),
    new Emoji(0x1f4b3, R.drawable.emoji_twitter_1f4b3),
    new Emoji(0x1f48e, R.drawable.emoji_twitter_1f48e),
    new Emoji(0x2696, R.drawable.emoji_twitter_2696),
    new Emoji(0x1f527, R.drawable.emoji_twitter_1f527),
    new Emoji(0x1f528, R.drawable.emoji_twitter_1f528),
    new Emoji(0x2692, R.drawable.emoji_twitter_2692),
    new Emoji(0x1f6e0, R.drawable.emoji_twitter_1f6e0),
    new Emoji(0x26cf, R.drawable.emoji_twitter_26cf),
    new Emoji(0x1f9ea, R.drawable.emoji_twitter_1f9ea),
    new Emoji(0x1f9eb, R.drawable.emoji_twitter_1f9eb),
    new Emoji(0x1f9ec, R.drawable.emoji_twitter_1f9ec),
    new Emoji(0x1f9ee, R.drawable.emoji_twitter_1f9ee),
    new Emoji(0x1f9ef, R.drawable.emoji_twitter_1f9ef),
    new Emoji(0x1f9f0, R.drawable.emoji_twitter_1f9f0),
    new Emoji(0x1f9f2, R.drawable.emoji_twitter_1f9f2),
    new Emoji(0x1f9f4, R.drawable.emoji_twitter_1f9f4),
    new Emoji(0x1f9f5, R.drawable.emoji_twitter_1f9f5),
    new Emoji(0x1f9f6, R.drawable.emoji_twitter_1f9f6),
    new Emoji(0x1f9f7, R.drawable.emoji_twitter_1f9f7),
    new Emoji(0x1f9f9, R.drawable.emoji_twitter_1f9f9),
    new Emoji(0x1f9fa, R.drawable.emoji_twitter_1f9fa),
    new Emoji(0x1f9fb, R.drawable.emoji_twitter_1f9fb),
    new Emoji(0x1f9fc, R.drawable.emoji_twitter_1f9fc),
    new Emoji(0x1f9fd, R.drawable.emoji_twitter_1f9fd),
    new Emoji(0x1f9fe, R.drawable.emoji_twitter_1f9fe),
    new Emoji(0x1f529, R.drawable.emoji_twitter_1f529),
    new Emoji(0x2699, R.drawable.emoji_twitter_2699),
    new Emoji(0x26d3, R.drawable.emoji_twitter_26d3),
    new Emoji(0x1f52b, R.drawable.emoji_twitter_1f52b),
    new Emoji(0x1f4a3, R.drawable.emoji_twitter_1f4a3),
    new Emoji(0x1f52a, R.drawable.emoji_twitter_1f52a),
    new Emoji(0x1f5e1, R.drawable.emoji_twitter_1f5e1),
    new Emoji(0x2694, R.drawable.emoji_twitter_2694),
    new Emoji(0x1f6e1, R.drawable.emoji_twitter_1f6e1),
    new Emoji(0x1f6ac, R.drawable.emoji_twitter_1f6ac),
    new Emoji(0x26b0, R.drawable.emoji_twitter_26b0),
    new Emoji(0x26b1, R.drawable.emoji_twitter_26b1),
    new Emoji(0x1f3fa, R.drawable.emoji_twitter_1f3fa),
    new Emoji(0x1f52e, R.drawable.emoji_twitter_1f52e),
    new Emoji(0x1f4ff, R.drawable.emoji_twitter_1f4ff),
    new Emoji(0x1f488, R.drawable.emoji_twitter_1f488),
    new Emoji(0x2697, R.drawable.emoji_twitter_2697),
    new Emoji(0x1f52d, R.drawable.emoji_twitter_1f52d),
    new Emoji(0x1f52c, R.drawable.emoji_twitter_1f52c),
    new Emoji(0x1f573, R.drawable.emoji_twitter_1f573),
    new Emoji(0x1f48a, R.drawable.emoji_twitter_1f48a),
    new Emoji(0x1f489, R.drawable.emoji_twitter_1f489),
    new Emoji(0x1f321, R.drawable.emoji_twitter_1f321),
    new Emoji(0x1f6bd, R.drawable.emoji_twitter_1f6bd),
    new Emoji(0x1f6b0, R.drawable.emoji_twitter_1f6b0),
    new Emoji(0x1f6bf, R.drawable.emoji_twitter_1f6bf),
    new Emoji(0x1f6c1, R.drawable.emoji_twitter_1f6c1),
    new Emoji(0x1f6c0, R.drawable.emoji_twitter_1f6c0,
      new Emoji(new int[] { 0x1f6c0, 0x1f3fb }, R.drawable.emoji_twitter_1f6c0_1f3fb),
      new Emoji(new int[] { 0x1f6c0, 0x1f3fc }, R.drawable.emoji_twitter_1f6c0_1f3fc),
      new Emoji(new int[] { 0x1f6c0, 0x1f3fd }, R.drawable.emoji_twitter_1f6c0_1f3fd),
      new Emoji(new int[] { 0x1f6c0, 0x1f3fe }, R.drawable.emoji_twitter_1f6c0_1f3fe),
      new Emoji(new int[] { 0x1f6c0, 0x1f3ff }, R.drawable.emoji_twitter_1f6c0_1f3ff)
    ),
    new Emoji(0x1f6ce, R.drawable.emoji_twitter_1f6ce),
    new Emoji(0x1f511, R.drawable.emoji_twitter_1f511),
    new Emoji(0x1f5dd, R.drawable.emoji_twitter_1f5dd),
    new Emoji(0x1f6aa, R.drawable.emoji_twitter_1f6aa),
    new Emoji(0x1f6cb, R.drawable.emoji_twitter_1f6cb),
    new Emoji(0x1f6cf, R.drawable.emoji_twitter_1f6cf),
    new Emoji(0x1f6cc, R.drawable.emoji_twitter_1f6cc,
      new Emoji(new int[] { 0x1f6cc, 0x1f3fb }, R.drawable.emoji_twitter_1f6cc_1f3fb),
      new Emoji(new int[] { 0x1f6cc, 0x1f3fc }, R.drawable.emoji_twitter_1f6cc_1f3fc),
      new Emoji(new int[] { 0x1f6cc, 0x1f3fd }, R.drawable.emoji_twitter_1f6cc_1f3fd),
      new Emoji(new int[] { 0x1f6cc, 0x1f3fe }, R.drawable.emoji_twitter_1f6cc_1f3fe),
      new Emoji(new int[] { 0x1f6cc, 0x1f3ff }, R.drawable.emoji_twitter_1f6cc_1f3ff)
    ),
    new Emoji(0x1f5bc, R.drawable.emoji_twitter_1f5bc),
    new Emoji(0x1f6cd, R.drawable.emoji_twitter_1f6cd),
    new Emoji(0x1f6d2, R.drawable.emoji_twitter_1f6d2),
    new Emoji(0x1f381, R.drawable.emoji_twitter_1f381),
    new Emoji(0x1f388, R.drawable.emoji_twitter_1f388),
    new Emoji(0x1f38f, R.drawable.emoji_twitter_1f38f),
    new Emoji(0x1f380, R.drawable.emoji_twitter_1f380),
    new Emoji(0x1f38a, R.drawable.emoji_twitter_1f38a),
    new Emoji(0x1f389, R.drawable.emoji_twitter_1f389),
    new Emoji(0x1f38e, R.drawable.emoji_twitter_1f38e),
    new Emoji(0x1f3ee, R.drawable.emoji_twitter_1f3ee),
    new Emoji(0x1f390, R.drawable.emoji_twitter_1f390),
    new Emoji(0x2709, R.drawable.emoji_twitter_2709),
    new Emoji(0x1f4e9, R.drawable.emoji_twitter_1f4e9),
    new Emoji(0x1f4e8, R.drawable.emoji_twitter_1f4e8),
    new Emoji(0x1f4e7, R.drawable.emoji_twitter_1f4e7),
    new Emoji(0x1f48c, R.drawable.emoji_twitter_1f48c),
    new Emoji(0x1f4e5, R.drawable.emoji_twitter_1f4e5),
    new Emoji(0x1f4e4, R.drawable.emoji_twitter_1f4e4),
    new Emoji(0x1f4e6, R.drawable.emoji_twitter_1f4e6),
    new Emoji(0x1f3f7, R.drawable.emoji_twitter_1f3f7),
    new Emoji(0x1f4ea, R.drawable.emoji_twitter_1f4ea),
    new Emoji(0x1f4eb, R.drawable.emoji_twitter_1f4eb),
    new Emoji(0x1f4ec, R.drawable.emoji_twitter_1f4ec),
    new Emoji(0x1f4ed, R.drawable.emoji_twitter_1f4ed),
    new Emoji(0x1f4ee, R.drawable.emoji_twitter_1f4ee),
    new Emoji(0x1f4ef, R.drawable.emoji_twitter_1f4ef),
    new Emoji(0x1f9ff, R.drawable.emoji_twitter_1f9ff),
    new Emoji(0x265f, R.drawable.emoji_twitter_265f),
    new Emoji(0x1f9f8, R.drawable.emoji_twitter_1f9f8),
    new Emoji(0x1f9e9, R.drawable.emoji_twitter_1f9e9),
    new Emoji(0x1f4dc, R.drawable.emoji_twitter_1f4dc),
    new Emoji(0x1f4c3, R.drawable.emoji_twitter_1f4c3),
    new Emoji(0x1f4c4, R.drawable.emoji_twitter_1f4c4),
    new Emoji(0x1f4d1, R.drawable.emoji_twitter_1f4d1),
    new Emoji(0x1f4ca, R.drawable.emoji_twitter_1f4ca),
    new Emoji(0x1f4c8, R.drawable.emoji_twitter_1f4c8),
    new Emoji(0x1f4c9, R.drawable.emoji_twitter_1f4c9),
    new Emoji(0x1f5d2, R.drawable.emoji_twitter_1f5d2),
    new Emoji(0x1f5d3, R.drawable.emoji_twitter_1f5d3),
    new Emoji(0x1f4c6, R.drawable.emoji_twitter_1f4c6),
    new Emoji(0x1f4c5, R.drawable.emoji_twitter_1f4c5),
    new Emoji(0x1f4c7, R.drawable.emoji_twitter_1f4c7),
    new Emoji(0x1f5c3, R.drawable.emoji_twitter_1f5c3),
    new Emoji(0x1f5f3, R.drawable.emoji_twitter_1f5f3),
    new Emoji(0x1f5c4, R.drawable.emoji_twitter_1f5c4),
    new Emoji(0x1f4cb, R.drawable.emoji_twitter_1f4cb),
    new Emoji(0x1f4c1, R.drawable.emoji_twitter_1f4c1),
    new Emoji(0x1f4c2, R.drawable.emoji_twitter_1f4c2),
    new Emoji(0x1f5c2, R.drawable.emoji_twitter_1f5c2),
    new Emoji(0x1f5de, R.drawable.emoji_twitter_1f5de),
    new Emoji(0x1f4f0, R.drawable.emoji_twitter_1f4f0),
    new Emoji(0x1f4d3, R.drawable.emoji_twitter_1f4d3),
    new Emoji(0x1f4d4, R.drawable.emoji_twitter_1f4d4),
    new Emoji(0x1f4d2, R.drawable.emoji_twitter_1f4d2),
    new Emoji(0x1f4d5, R.drawable.emoji_twitter_1f4d5),
    new Emoji(0x1f4d7, R.drawable.emoji_twitter_1f4d7),
    new Emoji(0x1f4d8, R.drawable.emoji_twitter_1f4d8),
    new Emoji(0x1f4d9, R.drawable.emoji_twitter_1f4d9),
    new Emoji(0x1f4da, R.drawable.emoji_twitter_1f4da),
    new Emoji(0x1f4d6, R.drawable.emoji_twitter_1f4d6),
    new Emoji(0x1f516, R.drawable.emoji_twitter_1f516),
    new Emoji(0x1f517, R.drawable.emoji_twitter_1f517),
    new Emoji(0x1f4ce, R.drawable.emoji_twitter_1f4ce),
    new Emoji(0x1f587, R.drawable.emoji_twitter_1f587),
    new Emoji(0x1f4d0, R.drawable.emoji_twitter_1f4d0),
    new Emoji(0x1f4cf, R.drawable.emoji_twitter_1f4cf),
    new Emoji(0x1f4cc, R.drawable.emoji_twitter_1f4cc),
    new Emoji(0x1f4cd, R.drawable.emoji_twitter_1f4cd),
    new Emoji(0x2702, R.drawable.emoji_twitter_2702),
    new Emoji(0x1f58a, R.drawable.emoji_twitter_1f58a),
    new Emoji(0x1f58b, R.drawable.emoji_twitter_1f58b),
    new Emoji(0x2712, R.drawable.emoji_twitter_2712),
    new Emoji(0x1f58c, R.drawable.emoji_twitter_1f58c),
    new Emoji(0x1f58d, R.drawable.emoji_twitter_1f58d),
    new Emoji(0x1f4dd, R.drawable.emoji_twitter_1f4dd),
    new Emoji(0x270f, R.drawable.emoji_twitter_270f),
    new Emoji(0x1f50d, R.drawable.emoji_twitter_1f50d),
    new Emoji(0x1f50e, R.drawable.emoji_twitter_1f50e),
    new Emoji(0x1f50f, R.drawable.emoji_twitter_1f50f),
    new Emoji(0x1f510, R.drawable.emoji_twitter_1f510),
    new Emoji(0x1f512, R.drawable.emoji_twitter_1f512),
    new Emoji(0x1f513, R.drawable.emoji_twitter_1f513)
  };

  @Override @NonNull public Emoji[] getEmojis() {
    return DATA;
  }

  @Override @DrawableRes public int getIcon() {
    return R.drawable.emoji_twitter_category_objects;
  }
}
